use handlebars::{Context, Handlebars, Helper, HelperDef, HelperResult, Output, RenderContext};

// implement by a structure impls HelperDef
#[derive(Clone, Copy)]
pub struct TimeOfDate;

impl HelperDef for TimeOfDate {
    fn call<'reg: 'rc, 'rc>(
        &self,
        h: &Helper,
        _: &Handlebars,
        _: &Context,
        _: &mut RenderContext,
        out: &mut dyn Output,
    ) -> HelperResult {
        let date = h
            .param(0)
            .and_then(|v| v.value().as_str())
            .unwrap_or("")
            .to_owned();
        let time_reversed = date.chars().rev();
        let only_time: String = time_reversed.take(8).collect();
        let only_minutes: String = only_time.chars().rev().take(5).collect();

        out.write(&only_minutes)?;
        Ok(())
    }
}
